
# CONTENTS

 * Introduction
 * Requirements
 * Installation
 * Configuration


## INTRODUCTION

Welcome to Decouple. This module is a progressive decoupling tool to help content
editors, site builders and front end developers with limited Drupal expertise to
build progressively decoupled Drupal application.

This module has a new entity "decouple". It enables content editors and site
builders to input information about data from Drupal, and enables front end developers
to input information about root element, JavaScript and CSS file. It automatically
builds a block to host the progressively decoupled Drupal application. The site
builders can use block layout UI to place the block in desired region, for example
content region. When users navigate to the decouple page, the progressively decoupled
Drupal application runs the front end JavaScript using data coming from Drupal.


### REQUIREMENTS

There are no special requirements at this time.


### INSTALLATION

 * Enable the "Decouple" module.

### UNINSTALLATION

* Uninstall the "Decouple" module.
* Delete nodes of the "decouple" content type.
* Delete the "decouple" content type.

### CONFIGURATION

 * Navigate to Block Layout (/admin/structure/block).
 * Add "Decouple block" block in desired region, for example content region.
 * Click `Configure` next to it to enter the block configuration page.
 * Turn off "display title".
 * Click the `Content types` tab under visibility conditions.
 * Select the "decouple" content type to ensure the block is only visible on pages that display nodes of the "decouple" content type.
 * Save the Block Configuration.
 * Scroll to the bottom of the block layout page and click `Save blocks`.

### USAGE

In Drupal, site builders can leverage Views to expose data as JSON feeds, enabling seamless integration for decoupled architectures.
The Drupal application can dynamically generate JSON data files to support decoupled frontends.

The following is an example about how to build and run a progressively decoupled Drupal application
using Drupal generated JSON data file to drive a front end JavaScript application.

* Copy example/data.json to /sites/default/files/decouple/data.json
* Copy example/fetchData.js to /sites/default/files/decouple/fetchData.js
* Copy example/fetchData.css to /sites/default/files/decouple/fetchData.css
* Navigate to `/node/add/decouple`.
* Input Title "Fetch Data".
* Input Root element ID "data-container".
* Input Data URL "/sites/default/files/decouple/data.json".
* Input JavaScript file path "/sites/default/files/decouple/fetchData.js".
* Input CSS file path "/sites/default/files/decouple/fetchData.css".
* Input URL alias "/decouple/fetchdata".
* Click `Save` to save the content.
* Navigate to `/decouple/fetchdata` page to run front end JavaScript with CSS using data from Drupal.
